module.exports = function(grunt) {

  grunt.initConfig({
    pkg: grunt.file.readJSON('package.json'),
    clean: {
      test: ['dist/test'],
      options: {
        force: true
      }
    },
    jshint: {
      all: [
        'lib/*.js',
        'src/**/*.js',
        'test/**/*.js'
      ],
      options: {
        globals: {
        }
      }
    },
    connect: {
      test: {
      },
      server: {
        options: {
          hostname: '0.0.0.0',
          keepalive: true
        }
      }
    },
    blanket_qunit: {
      all: {
        options: {
          urls: [
            // 'http://localhost:8000/test/000-qunit-basic.html',
            // 'http://localhost:8000/test/001-qunit-basic-amd.html',
            // 'http://localhost:8000/test/010-jquery-basic-amd.html',
            // 'http://localhost:8000/test/011-jquery-basic-amd-curl.html',
            // 'http://localhost:8000/test/012-jquery-loaded-amd.html',
            // 'http://localhost:8000/test/013-jquery-loaded-amd-curl.html',
            // 'http://localhost:8000/test/020-js-errors.html',
            'http://localhost:8000/test/jssl.html?coverage=true&gruntReport'
          ],
          threshold: 20,
        },
      },
    },
    qunit_junit: {
      options: {
        dest: 'dist/test',
      },
    },
  });

  grunt.loadNpmTasks('grunt-contrib-clean');
  grunt.loadNpmTasks('grunt-contrib-jshint');
  grunt.loadNpmTasks('grunt-contrib-connect');
  grunt.loadNpmTasks('grunt-blanket-qunit');
  grunt.loadNpmTasks('grunt-qunit-junit');
  grunt.loadNpmTasks('grunt-blanket');

  // Test task.
  grunt.registerTask('test', [
    'clean',
    'jshint',
    'connect:test',
    'blanket_qunit'
  ]);

  // Default task
  grunt.registerTask('default', [
    'jshint',
    'test'
  ]);
};
