/*global Document*/

define([
  '../../core/Initializer',
  '../../mixins/TypedCapsule'
], function (Initializer, TypedCapsule) {
  'use strict';

  return Initializer.extend('AbstractDomAdapter', [
    new TypedCapsule('context', Document)
  ], {

    initContext: function(context) {
      this.setContext(context);
    },

    find: function(expression, context) {
      var c = context || this.getContext();
      if(!c) {
        throw new Error('Missing context'); // TODO Better error
      }
      return this.createContext(c).find(expression);
    }

  });

});
