define([
    './AbstractWebServiceAdapter',
    'jquery'
  ],
  function (AbstractWebServiceAdapter, $) {
    'use strict';

    return AbstractWebServiceAdapter.extend('JQueryWebServiceAdapter', {

      send: function(method, relativeUrl, options) {
        var deferred = $.ajax(
          this.getBaseUrl() + relativeUrl,
          $.extend(true, {}, options, { type: method }, this.getOptions())
        );
        return {
          then: function(successCallback, errorCallBack) {
            return errorCallBack ? deferred.done(successCallback).fail(errorCallBack) : deferred.done(successCallback);
          },
          fail: deferred.fail
        };
      }

    });
  }
);
