define([
    'jssl/core/Class',
    'jssl/mixins/StringCapsule',
    '../error/MissingArgumentError'
  ],
  function (Class, StringCapsule, MissingArgumentError) {
    'use strict';

    return Class.extend('Url', [
        new StringCapsule('value')
      ], {

        init: function (url) {
          if(!url) {
            throw new MissingArgumentError('url');
          }
          this.setValue(url);
        },

        toString: function() {
          return this.getValue();
        }
      });
  }
);
