define(['./JsslError'], function (JsslError) {
  'use strict';

  function MissingImplementationError(constructor, methodName) {
    var _name = this.name = this.constructor.name;
    this.message = 'Class "' + (constructor && constructor.name || constructor) + '" must implement the method ' + methodName + '()';
    try { throw new Error(); } catch(e) { this.stack = e.stack.split('\n').filter(function(l) { return !new RegExp('^(\\s+at (new )?)?' + _name + '( |@)').test(l); }).join('\n').replace(/^Error/, this.toString()); }
  }
  MissingImplementationError.prototype = new JsslError();
  MissingImplementationError.prototype.constructor = MissingImplementationError;
  if(!MissingImplementationError.name) MissingImplementationError.name = 'MissingImplementationError';
  /*
  return JsslError.extend('ArgumentError', function (constructor, methodName) {
    this.message = 'Class "' + constructor + '" must implement the method ' + methodName + '()';
  });

  /*
  function ArgumentError(constructor, methodName) {
    this.message = 'Class "' + constructor + '" must implement the method ' + methodName + '()';
  }

  ArgumentError.prototype = new JsslError();
  ArgumentError.prototype.constructor = ArgumentError;

  return ArgumentError;
  */

  return MissingImplementationError;
});
