define(['./Capsule'], function (Capsule) {
  'use strict';

  function merge() {
    var i, j;
    for(i = 1 ; i < arguments.length ; i++) {
      for(j in arguments[i]) {
        if(arguments[i].hasOwnProperty(j)) {
          arguments[0][j] = arguments[i][j];
        }
      }
    }
  }

  var TypedCapsule = function TypedCapsule (fieldName, theClass, options) {
    return new Capsule(fieldName, merge({
      validators: [
        function (value) {
          return value === undefined || value instanceof theClass;
        }
      ]
    }, options)).extend('TypedCapsule', {});
  };

  return TypedCapsule;
});
